"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var Comlink = __importStar(require("comlinkjs"));
function createWorkerContext(worker, selector) {
    var _this = this;
    if (selector === void 0) { selector = function (s) { return s; }; }
    var StateContext = react_1.default.createContext(null);
    var ProxyContext = react_1.default.createContext(null);
    var storeProxy = Comlink.proxy(worker);
    // build initialState
    var currentSnapshot = null;
    var ready = storeProxy.getState().then(function (state) { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, selector(state)];
                case 1:
                    currentSnapshot = _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    function useStore() {
        var _this = this;
        var _a = react_1.useState(currentSnapshot), current = _a[0], setState = _a[1];
        currentSnapshot = current;
        // subsribe remote state
        react_1.useEffect(function () {
            var subscriptionIdPromise = storeProxy.subscribe(Comlink.proxyValue(function (snapshot) {
                currentSnapshot = snapshot;
                setState(snapshot);
            }), Comlink.proxyValue(selector));
            // Set initialState at null
            currentSnapshot == null &&
                storeProxy.getState().then(function (state) { return __awaiter(_this, void 0, void 0, function () {
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4 /*yield*/, selector(state)];
                            case 1:
                                currentSnapshot = _a.sent();
                                setState(currentSnapshot);
                                return [2 /*return*/];
                        }
                    });
                }); });
            return function () { return __awaiter(_this, void 0, void 0, function () {
                var subscriptionId;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, subscriptionIdPromise];
                        case 1:
                            subscriptionId = _a.sent();
                            storeProxy.unsubscribe(subscriptionId);
                            return [2 /*return*/];
                    }
                });
            }); };
        }, []);
        return [current, storeProxy];
    }
    function WorkerContext(props) {
        var _a = useStore(), current = _a[0], proxy = _a[1];
        if (current == null) {
            return props.fallback || react_1.default.createElement("div", null);
        }
        else {
            return (react_1.default.createElement(ProxyContext.Provider, { value: proxy },
                react_1.default.createElement(StateContext.Provider, { value: current }, props.children)));
        }
    }
    // TODO: Supress update by isEqual
    function useSnapshot(selector) {
        if (selector === void 0) { selector = function (i) { return i; }; }
        var snapshot = react_1.useContext(StateContext);
        var selected = selector(snapshot);
        return selected;
    }
    function useDispatch() {
        var proxy = react_1.useContext(ProxyContext);
        return proxy.dispatch;
    }
    return {
        WorkerContext: WorkerContext,
        useSnapshot: useSnapshot,
        useDispatch: useDispatch,
        ready: ready
    };
}
exports.createWorkerContext = createWorkerContext;
